api/urls.py
from django.urls import path
from rest_framework.urlpatterns import format_suffix_patterns
from api.views import basic_views


app_name = 'api_url'
urlpatterns = [
    path('get_data/<str:jenis>/', basic_views.GetDataViewsets.as_view()),
    # path('getaboutme/<str:section>/', basic_views.AboutMeViewsets.as_view()),
    # path('getlayanan/', basic_views.LayananViewsets.as_view()),
    # path('getrecommend_produk/<str:jenis>/<int:len_data>/', basic_views.ProdukRecommendViewsets.as_view()),
    # path('getallproduct/<str:jenis>/', basic_views.AllProdukViewsets.as_view()),
    # path('getproduct/<str:idproduct>/', basic_views.ProductViewset.as_view()),
    # path('orderdetail/', basic_views.OrderDetail.as_view(), name = 'orderdetail'),
    # path('sendotp/', basic_views.SendOTP.as_view(), name = 'sendotp'),
    # path('verifyotp/', basic_views.VerifyOTP.as_view(), name = 'verifyotp'),
    # path('sendemailpesananclient/', basic_views.SendEmailPesananClient.as_view(), name = 'sendemailpesananclient'),
    # path('sendemailpesananadmin/', basic_views.SendEmailPesananAdmin.as_view(), name = 'sendemailpesananadmin'),
    # path('get_all_order/', basic_views.GetAllOrder.as_view(), name = 'get_all_order'),
    # path('kirim_bukti_bayar/', basic_views.KirimBuktiBayar.as_view(), name = 'kirim_bukti_bayar'),
    # path('batalkan_pesanan/', basic_views.BatalkanPesanan.as_view(), name = 'batalkan_pesanan'),
    # path('productcategory/', basic_views.CategoryViewsets.as_view()),
    # path('productcategorydetail/<slug:slug>/', basic_views.CategoryDetailViewsets.as_view()),
]

urlpatterns = format_suffix_patterns(urlpatterns)

rizq_sanjaya_app/urls.py
from django.urls import path, include
from .views import *
from django.contrib.auth import views as auth_views


app_name = 'profile'
urlpatterns = [
    # PATH URL UNTUK ADMIN 
    path('manage_panel/', include(
        [
            path('', admin.index, name='admin_home'),
            path('verification/', user.verification, name='admin_verification'),
            path('send_verification/', user.send_verification, name='admin_send_verification'),
            path('email/verify/<uidb64>/<token>/',user.email_verify, name='admin_email_verify'),
            # LRA JENIS =====================================
            path('lra_jenis/', include(
            [
                path('', lra_jenis.admin_index, name='admin_lra_jenis'),
            ]
            )),

            # LRA objek =====================================
            path('lra_objek/', include(
            [
                path('', lra_objek.admin_index, name='admin_lra_objek'),
            ]
            )),

            # LRA Rekening =====================================
            path('lra_rekening/', include(
            [
                path('', lra_rekening.admin_index, name='admin_lra_rekening'),
            ]
            )),

            # OPD Peringkat =====================================
            path('opd_peringkat/', include(
            [
                path('', opd_peringkat.admin_index, name='admin_opd_peringkat'),
            ]
            )),

            # Real Rekening =====================================
            path('lra_real_rekening/', include(
            [
                path('', lra_real_rekening.admin_index, name='admin_lra_real_rekening'),
            ]
            )),
             # OPD Peringkat =====================================
            path('pejabat_pengesah/', include(
            [
                path('', pejabat_pengesah.admin_index, name='admin_pejabat_pengesah'),
            ]
            )),


            # USERS
            path('user/', include(
                [
                    path('', user.admin_index, name='admin_user'),
                    path('create/', user.create, name='admin_user_create'),
                    path('password/edit/', user.edit_password, name='admin_user_password_edit'),
                    path('profile/edit/<str:username>', user.edit_profile, name='admin_user_edit'),
                    path('avatar/edit/<str:username>', user.edit_avatar, name='admin_user_avatar_edit'),
                    path('detail/', user.admin_detail, name='admin_user_detail'),
                    path('soft_delete/<str:username>', user.softDelete, name='admin_user_soft_delete'),
                    path('permanent_delete/<str:slug>', user.permanentDelete, name='admin_user_permanent_delete'),
                    path('restore/<str:username>', user.restore, name='admin_user_restore'),
                    path('edit_role/', user.edit_role, name='admin_user_edit_role'),
                    path('non_aktif/<int:id>', user.non_aktif, name='non_aktif'),
                    path('re_aktif/<int:id>', user.re_aktif, name='aktif'),
                ]
            )),

            # SETTING APLIKASI
            path('setting/', include(
                [
                    # path('', user.admin_index, name='admin_setting'),
                    path('infografis/', setting.admin_index_infografis, name='admin_setting_infografis'),
                   
                ]
            )),
        ]
    ))
]

rizq_sanjaya_app/forms/profile.py
from django import forms
from ..models import *
from PIL import Image
from django.conf import settings
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django import forms
from captcha.fields import CaptchaField

# class CategoryForm(forms.ModelForm):
# 	class Meta:
# 		model = Category
# 		fields = ('id', 'nama','typexs',)

class AvatarForm(forms.ModelForm):
	x = forms.FloatField(widget=forms.HiddenInput())
	y = forms.FloatField(widget=forms.HiddenInput())
	width = forms.FloatField(widget=forms.HiddenInput())
	height = forms.FloatField(widget=forms.HiddenInput())

	class Meta:
		model = Account
		fields = ('avatar', 'x', 'y', 'width', 'height',)

	def save(self):
		account = super(AvatarForm, self).save()
		x = self.cleaned_data.get('x')
		y = self.cleaned_data.get('y')
		w = self.cleaned_data.get('width')
		h = self.cleaned_data.get('height')

		image = Image.open(account.avatar)
		cropped_image = image.crop((x, y, w + x, h + y))
		cropped_image.save(f"{settings.MEDIA_ROOT}{account.avatar.name}")

		return account

class AccountForm(forms.ModelForm):
	class Meta:
		model = Account
		fields = ('first_name', 'last_name', 'phone', 'date_of_birth')

class RoleForm(forms.ModelForm):
	class Meta:
		model = Account
		fields = ('role',)

class CustomUserCreationForm(UserCreationForm):
	class Meta:
		model = Account
		fields = ('email', 'username', 'first_name', 'last_name', 'role', 'phone', 'date_of_birth',)

rizq_sanjaya_app/views/admin.py
from django.shortcuts import render, HttpResponse
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods

from rizq_sanjaya_app.decorators import is_verified
from ..forms import *
from ..models import *
from django.db import connections
from ..helpers import dictfetchall

@login_required
@is_verified()
@require_http_methods(["GET"])
def index(request):
    halo = 'welcome'
    context = {
        'Welcome' : halo,
        
    }
    return render(request, 'profile/admin/index.html', context)

rizq_sanjaya_app/views/dashboard_.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from ..models import News
from django.utils import timezone
from django.conf import settings
from datetime import datetime
from ..decorators import *
from django.db import connection
from django.db.models import Q, Count
import os
from django.template.loader import render_to_string
import requests



@require_http_methods(["GET"])
def index(request):
     title = 'Sistem Informasi Monotoring Data Anggaran Provinsi Papua Tengah'
     description = 'Aplikasi ini dibuat untuk memonitor data pergerakan anggaran dan realisasi secara realtime dan memberikan kemudahan dalam penyejian data pelaporan kepada eksekutif / pimpinan daerah'
     dataLanding = {
          'Title' : title,
          'Description' : description,
     }
     
     return render(request, 'frontend/index.html',dataLanding)

rizq_sanjaya_app/views/lra_jenis.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from django.utils import timezone
import os
from django.conf import settings
from datetime import datetime
from ..decorators import *
from django.db.models.functions import Substr, StrIndex

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    context = {
        'title' : 'Monitoring LRA Jenis',
    }
    
    return render(request, 'profile/admin/lra_jenis/index.html', context)

rizq_sanjaya_app/views/lra_objek.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from django.utils import timezone
import os
from django.conf import settings
from datetime import datetime
from ..decorators import *
from django.db.models.functions import Substr, StrIndex

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    context = {
        'title' : 'Monitoring LRA Objek',
    }
    
    return render(request, 'profile/admin/lra_objek/index.html', context)

rizq_sanjaya_app/views/lra_real_rekening.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from django.utils import timezone
import os
from django.conf import settings
from datetime import datetime
from ..decorators import *
from django.db.models.functions import Substr, StrIndex

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    context = {
        'title' : 'Monitoring LRA Real Rekening',
    }
    
    return render(request, 'profile/admin/lra_real_rekening/index.html', context)

rizq_sanjaya_app/views/lra_rekening.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from django.utils import timezone
import os
from django.conf import settings
from datetime import datetime
from ..decorators import *
from django.db.models.functions import Substr, StrIndex

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    context = {
        'title' : 'Monitoring LRA Rekening',
    }
    
    return render(request, 'profile/admin/lra_rekening/index.html', context)

rizq_sanjaya_app/views/opd_peringkat.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from django.utils import timezone
import os
from django.conf import settings
from datetime import datetime
from ..decorators import *
from django.db.models.functions import Substr, StrIndex

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    context = {
        'title' : 'Monitoring OPD Peringkat',
    }
    
    return render(request, 'profile/admin/opd_peringkat/index.html', context)

rizq_sanjaya_app/views/pejabat_pengesah.py
from django.shortcuts import render, HttpResponse, redirect, get_object_or_404
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from django.utils import timezone
import os
from django.conf import settings
from datetime import datetime
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from ..decorators import *
from django.db.models.functions import Substr, StrIndex
from ..helpers import querytags, get_list_berita, get_category

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    page = request.GET.get('page', 1)
    data_master_pejabat = master_pejabat_pengesah.objects.all()
    archives = master_pejabat_pengesah.objects.all()
    paginator = Paginator(data_master_pejabat, 15)
    try:
        data_master_pejabat = paginator.page(page)
    except PageNotAnInteger:
        data_master_pejabat = paginator.page(1)
    except EmptyPage:
        data_master_pejabat = paginator.page(paginator.num_pages)

    context = {
        'title' : 'Master Pejabat Pengesah',
        'data_master_pejabat' : data_master_pejabat,
        'archives' : archives,
    }
    
    return render(request, 'profile/admin/pejabat_pengesah/index.html', context)

# @login_required
# @is_verified()
# def create(request):
#     template = ''
#     context = {} 
#     form = ''

#     if request.method == 'GET':
#         form = Kata.objects.all()
#         context = {
#             'title' : 'ADD KATA MEREKA',
#             'form' : form,
#         }

#         template = 'profile/admin/kata/create.html'
#         return render(request, template, context)
    
#     if request.method == 'POST':
#         image = request.FILES['image']
#         judul = request.POST.get('judul')
#         keterangan = request.POST.get('keterangan')
#         if judul is not None:
#             new_news = Kata()
#             new_news.image = image
#             new_news.judul = judul
#             new_news.keterangan = keterangan
#             new_news.save()
            
#             messages.success(request, 'Kata Mereka berhasil disimpan.')
#             return redirect('profile:admin_KM')

#         messages.error(request, 'Kata Mereka gagal disimpan.')
#         return render(request, 'profile/admin/kata/create.html', {'form': form,})
    
# @login_required
# @is_verified()
# def edit(request, id):
#     template = ''
#     context = {} 
#     form = ''
    
#     if request.method == 'GET':
#         news = Kata.objects.get(id = id)

#         context = {
#             'title' : 'EDIT KATA MEREKA',
#             'form' : form,
#             'edit' : 'true',
#             'news' : news,
#         }
#         template = 'profile/admin/kata/create.html'
#         return render(request, template, context)
    
#     if request.method == 'POST':
#         news = Kata.objects.get(id = id)
#         path_file_lama = f"{settings.MEDIA_ROOT}/{news.image}"
#         foto_old = bool(news.image)
#         judul = request.POST.get('judul')
#         keterangan = request.POST.get('keterangan')

#         if news is not None:
#             news.judul = judul
#             news.keterangan = keterangan
#             news.save()
    
#             if 'image' in request.FILES:
#                 if foto_old : 
#                     try:
#                         os.remove(path_file_lama)
#                     except:
#                         pass
#                 foto = request.FILES['image']
#                 news.image = foto
#                 news.save()

#             messages.success(request, 'Kata Mereka berhasil disimpan')
#             return redirect('profile:admin_KM')

#         messages.error(request, 'Kata Mereka gagal disimpan.')
#         return render(request, 'profile/admin/kata/create.html', {'form': form,})

# @login_required
# @is_verified()
# @require_http_methods(["GET"])
# def admin_detail(request, id):
#     template = 'profile/admin/kata/detail.html'
#     try:
#         news = Kata.objects.get(id=id)
#     except Kata.DoesNotExist:
#         news = None
#     context = {
#         'title' : news.judul if news != None else 'TIDAK DITEMUKAN',
#         'news' : news,
#     }
#     return render(request, template, context)

# @login_required
# @is_verified()
# def softDelete(request, id):
#     message = ''
#     try:
#         sekarang = timezone.now()
#         doc = Kata.objects.get(id=id)
#         doc.deleted_at = sekarang
#         doc.save()
#         message = 'success'
#     except Kata.DoesNotExist:
#         message = 'error'

#     context = {
#             'message' : message,
#         }

#     return HttpResponse(context)

# @login_required
# @is_verified()
# def permanentDelete(request, id):
#     message = ''
#     try:
#         doc = Kata.objects.get(id=id)
#         try:
#             doc.image.delete()
#         except:
#             pass
#         doc.delete()
#         message = 'success'
#     except Kata.DoesNotExist:
#         message = 'error'

#     context = {
#             'message' : message,
#         }

#     return HttpResponse(context)
    
# @login_required
# @is_verified()
# def restore(request, id):
#     message = ''
#     try:
#         doc = Kata.objects.get(id=id)
#         doc.deleted_at = None
#         doc.save()
#         message = 'success'
#     except Kata.DoesNotExist:
#         message = 'error'

#     context = {
#             'message' : message,
#         }

#     return HttpResponse(context)

rizq_sanjaya_app/templates/profile/admin/lra_objek/index.html
{% extends 'profile/layouts/admin/admin_layout.html' %}
{% load static %}

{% block css %}
    <link rel="stylesheet" type="text/css" href="{% static 'profile/css/datatables/datatables.min.css' %}">
    <link rel="stylesheet" type="text/css" href="{% static 'profile/css/datatables/datatables-responsive.css' %}">
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}

    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Monitoring / LRA Objek</li>
        </ol>
    </nav>

    <a href="{% url 'profile:admin_user_create' %}"> 
        <button type="button" class="btn btn-info mt-2 mb-4"><i class="bi bi-plus"></i> Uplad Data LRA Objek</button>
    </a>
    

    <div class="card shadow mb-5">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-info">Data LRA Objek</h6>
            <div class="dropdown no-arrow">
                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
            </div>
        </div>
        <div class="card-body">
            <div class="table-responsive py-3">
                <table class="table table-striped table-bordered dt-responsive nowrap" width="100%" id="table-list">
                    <thead class="bg-info text-white">
                        <tr>
                            <th scope="col" class="text-center">ID</th>
                            <th scope="col" class="text-center">created_at</th>
                            <th scope="col" class="text-center">updated_at</th>
                            <th scope="col" class="text-center">deleted_at</th>
                            <th scope="col" class="text-center">Tahun</th>
                            <th scope="col" class="text-center">Kode_Rekening</th>
                            <th scope="col" class="text-center">Uraian</th>
                            <th scope="col" class="text-center">Anggaran_Sebelum_Pergeseran</th>
                            <th scope="col" class="text-center">Anggaran_Setelah_Pergeseran</th>
                            <th scope="col" class="text-center">Selisih</th>
                            <th scope="col" class="text-center">Realisasi</th>
                            <th scope="col" class="text-center">Persentase</th>
                            <th scope="col" class="text-center">Sisa</th>
                            <th scope="col" class="text-center">Bulan</th>
                            <th scope="col" class="text-center">Status</th>

                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>1</td>
                            <td>2023-10-03</td>
                            <td>2023-10-03</td>
                            <td>null</td>
                            <td>2023</td>
                            <td>12345</td>
                            <td>Deskripsi Rekening</td>
                            <td>1000000</td>
                            <td>900000</td>
                            <td>100000</td>
                            <td>800000</td>
                            <td>80%</td>
                            <td>100000</td>
                            <td>Januari</td>
                            <td>Aktif</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    
{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    <script src="{% static 'profile/js/datatables/datatables.min.js' %}"></script>
    <script src="{% static 'profile/js/admin/admin-aksi.js' %}"></script>
    <script>
        $(document).ready( function () {
            $('[data-tooltip="tooltip"]').tooltip();
            $('#table-list').DataTable({
                responsive: true,
            });
            $('#table-archive').DataTable({
                responsive: true,
            });
        });
    </script>
{% endblock scripts_bawah %}